clutchlog::fmt::color_16M Struct Reference
Internal colors management in 256 and 16M colors modes.

Abstract base class for 16M colors objects (24-bits ANSI). More...

`#include <clutchlog.h>`

Inheritance diagram for clutchlog::fmt::color_16M:
[legend]
Collaboration diagram for clutchlog::fmt::color_16M:
[legend]

## Detailed Description

Abstract base class for 16M colors objects (24-bits ANSI).

Definition at line 573 of file clutchlog.h.

## Public Member Functions

| color_16M (ground t)
| Constructor. More...
| color_16M (ground t, short r, short g, short b)
| Numeric triplet constructor. More...
| color_16M (ground t, const std::string &srgb)
| Hex triplet string constructor. More...
bool | is_set () const
| Returns true if the underying representation encodes an existing color.
std::ostream & | print_on (std::ostream &os) const
| Print the color RGB triplet on the given stream.
Public Member Functions inherited from clutchlog::fmt::color
| color (ansi a, ground g)
| Constructor. More...

## Public Attributes

short | red
| The encoded RGB indices. More...
short | green
short | blue
Public Attributes inherited from clutchlog::fmt::color
ansi | mode
enum clutchlog::fmt::color::ground | type
| Type of color (foreground or background).

## Additional Inherited Members

Public Types inherited from clutchlog::fmt::color
enum | ground { fore = 38, back = 48 }
| Codes for representing foreground or background.

## Constructor & Destructor Documentation

## color_16M() [1/3]

clutchlog::fmt::color_16M::color_16M | ( | ground | t | ) |

inline

Constructor.

Parameters

  t | Foreground or background tag.

Definition at line 582 of file clutchlog.h.

## color_16M() [2/3]

clutchlog::fmt::color_16M::color_16M | ( | ground | t,
|  | short | r,
|  | short | g,
|  | short | b
| ) |  |

inline

Numeric triplet constructor.

Parameters

  t | Foreground or background tag.
  r | Red color component.
  g | Green color component.
  b | Blue color component.

Definition at line 591 of file clutchlog.h.

## color_16M() [3/3]

clutchlog::fmt::color_16M::color_16M | ( | ground | t,
|  | const std::string & | srgb
| ) |  |

inline

Hex triplet string constructor.

Note
  If the given string is ill-formed, it will silently encode a "no color".

Parameters

  t | Foreground or background tag.
  srgb | A "web color" hexadecimal triplet of two characters, starting with a leading number sign (e.g. "#0055ff").

Definition at line 601 of file clutchlog.h.

References red.

## Member Data Documentation

## red

short clutchlog::fmt::color_16M::red

The encoded RGB indices.

"No color" is encoded as -1.

Definition at line 577 of file clutchlog.h.

Referenced by color_16M(), is_set(), and print_on().

The documentation for this struct was generated from the following file:

- clutchlog.h